(load "oops.scm")

;; Create the object, which will play the class role.  
(define <point> (oops:make-object ()))

;; Define the initializer slot: it's called each time a derived
;; (i.e. having this one as a parent) object is created.
(oops:define (initialize <point>)
  (lambda (self next)
    (>> self x 0)
    (>> self y 0)

    ;; One way to define methods.
    (>> self get-x (lambda (self next) (<< self x)))
    (>> self set-x! (lambda (self next val) (>> self x val)))))

;; Another way to define methods.
(oops:define (get-y <point>) (lambda (self next) (<< self y)))
(oops:define (set-y! <point>) (lambda (self next val) (>> self y val)))

;; Create a point. 
(define p (oops:make-object (<point>)))
;; no values returned 

(: p get-x) 
;; 0 

(: p set-x! 5)
;; #{Unspecific} 

(<< p x)
;; 5 
  
;; Testing inheritance 
(define <colored-point> (oops:make-object (<point>)))

(oops:define (initialize <colored-point>)
  (lambda (self next)
    (: next initialize)
    (>> self color 'red)))

(oops:define (get-color <colored-point>)
  (lambda (self next)
    (<< self color)))

(oops:define (set-color! <colored-point>)
  (lambda (self next new-color)
    (>> self color new-color)))

(define cp (oops:make-object (<colored-point>)))
;; no values returned 

(: cp get-color)
;; 'red 

(: cp get-x)
;; 0 

(: cp set-x! 5) 
;; #{Unspecific}

(: cp get-x) 
;; 5
